/* Copyright (c) 1989 by Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

#include "../copyright.h"
#include <stdio.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/dir.h>
#include "../forumnet.h"
#include "externs.h"
#include "../version.h"

main (argc, argv)
int argc;
char **argv;
{
	int c;
	int debugflg = 0;
	char server[MAXNAMLEN];
	extern char *optarg;
	int mfd;
	int askpass = 0;
	extern int optind;
	char *getenv(), *getlogin(), *getpass();

	while ((c = getopt(argc, argv, "g:hn:pw")) != EOF)
		switch (c) {

		case 'g':
			mygroup = optarg;
			break;

		case 'n':
			myname = optarg;
			break;

		case 'p':
			askpass++;
			break;

		case 'w':
			whoflg++;
			break;

		case 'h':
		case '?':
		default:
			fprintf(stderr, "Usage: forum [-n nickname]\n");
			exit(-1);
			break;
	}

	if (!whoflg)
		printf("Forum client revision %s.\n", VERSION);

	if (askpass)
		mypass = getpass("Password:");

	/* read the startup file */
	readforumrc();

	/* get our nickname */
	if (myname == 0)
		if ((myname = getenv("FORUMNAME")) == NULL)
			if ((myname = getlogin()) == NULL) {
				puts("Sorry, can't figure out your name.");
				puts("Try forum -n myname.");
				exit(-1);
			}
				
	
	/* start up the server if we can and if we must */
	gethostname(thishost, 127);

	/* can you believe this program uses random numbers? */
	srandom((unsigned)time(0));

	/* try to connect to port - if it fails, start server if we are on */
	/* same machne then try again */

	if ((connecttoport(hostname, portnumber)) < 0) {
		if (strcmp(hostname, thishost) != 0) {
			/* remote host - no way to start server */
			perror("forum: remote server not running");
			exit(-1);
		}
		sprintf(server, "%s/forumnet", LIBDIR);
		if (vfork() == 0) {
			execl(server, "forumnet", 0);
			perror("forum: can't restart local server");
			exit(-1);
		} else
			sleep(1);

		if ((connecttoport(hostname, portnumber)) < 0) {
			perror("forum: can't connect to server");
			exit(-1);
		}
	}

	/* set up strange and arcane terminal modes */
	setterm();

	/* trap signals */
	trapsignals();

	/* start the serve loop */
	if (clientserve() < 0) {
		perror("clientserve failed");
		exit(-1);
	}

	/* all's well that ends */
	exit(0);
}
