/* Copyright (c) 1989 by Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

/* message history routines */

#include "../copyright.h"
#include <stdio.h>
#include "../forumnet.h" 

struct Namelist *head, *tail;	/* head and tail of list */

int histmax = 20;	/* max number of history entries */
int histnum = 0;	/* current number of history entries */
struct Namelist *curptr;	/* user's current location in history list */


/* add a username to the list */
/* called whenever a user sends a personal message to another */

histput(name)
char *name;
{
	char *malloc();
	struct Namelist *p;

	/* hunt for user within list */
	for (p = head; p != 0; p = p->next) {
		if (!strcicmp(name, p->name)) {
			/* found user -- put at head of list */
			nameunlink(p, &head, &tail);
			nameheadlink(p, &head, &tail);
			curptr = head;
			return(0);
		}
	}

	/* user wasn't found */
	if (histnum < histmax) {
		/* there is space left -- make a new entry for the user */
		if ((p = (struct Namelist *) malloc ((unsigned)
		 sizeof(struct Namelist))) == NULL) {
			fprintf(stderr, "hist: malloc failed\n");
			return(0);
		}
		strcpy(p->name, name);
		nameheadlink(p, &head, &tail);
		histnum++;
	} else {
		/* no space left -- link user to head, remove tail */
		p = tail;
		strcpy(p->name, name);
		nameunlink(p, &head, &tail);
		nameheadlink(p, &head, &tail);
	}
	curptr = head;
}

/* return a history entry */
/* repeatedly called, will cycle through history entries */

char *
histget()
{
	struct Namelist *p = curptr;

	curptr = curptr->next;
	if (curptr == 0)
		curptr = head;
	return(p->name);
}
	

/* return number of names in current history list */

histcount()
{
	return(histnum);
}
