/* Copyright (c) 1988 Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

/* main program loop */
/* active clients, new connections, and perform asynch dungeon action */

#include "../copyright.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <errno.h>
#ifdef FCNTL
#include <fcntl.h>
#endif FCNTL
#include "select.h"
#include "ipcf.h"
#include "externs.h"
 
extern int errno;
fd_set fdr;	
int timeisup;

serverserve()
{
	int ret;
	int alarm();
	long loopcount = 0; /* used to break loop for periodic didpoll */

	/* look at fd where new clients connect */
	FD_ZERO(&fdset);
	FD_SET(port_fd,&fdset);

	signal(SIGALRM, alarm);
	timeisup = 0;

	for (;;) {
		if (polldelay) {
			if (setitimer(ITIMER_REAL, polldelay, 0) < 0) {
				perror("server: setitimer failed");
				exit(-1);
			}
			timeisup = 0;
/*			sigpause(0); /**/
		}


		fdr = fdset;	/* should be a bcopy if larger than int */

		/* wait for input */
		/* NULL should be changed to a time value that reflects */
		/* how much activity is going on */

		if ((ret = select(FD_SETSIZE, &fdr, 0, 0, polltimeout)) < 1) {
			if (ret == 0 || errno == EINTR) {
				s_didpoll();
				timeisup = 0;
			} else {
				perror("select");
				exit(-1);
			}
		}

		if (ret > 0)
			sdoinput();
		if (timeisup || !(++loopcount % 10))
			s_didpoll();
	}
}

alarm()
{
	timeisup++;
}

sdoinput()
{
	int n;
	register int x;
	register long bits;

	/* examine set of file descriptors */
	if (bits = fdr.fds_bits[0])
	    for (x = 0; bits; x++, bits >>= 1)
		if (bits & 1)
			if (x == port_fd) {
				/* new connect on advertised socket */
				if ((n = _newconnect(x)) <= 0)
					logerr(WARN,"serve");
				else
					/* let server init the user */
					s_new_user(n);
			} else {
				/* fd is client input */
				switch(_readpacket(x, &cbufs[x])) {
				case  1:
					/* complete packet */
					s_packet(x, cbufs[x].buf);
					break;
				case  0:
					/* incomplete packet */
					break;
				case -1:
					/* error */
					logerr(WARN,"serve");
					break;
				case -2:
					/* close connection */
					disconnectuser(x);
					break;
				}
			}
}
